﻿//通信関連関数

var logdata = "";
var logalldata = "";
var httpObj = null;

//クッキーを使いキャッシュ対策
var lctsch = location.search;
var lctschs = null;
if (lctsch.length > 0) {
	lctschs = lctsch.substring(1).split("&");
	var i;
	for (i in lctschs) {
		if (lctschs[i].match(/^clear$/) != null)  { //クッキーを意図的に削除したい場合 URL に shukei.htm?clear 
			clearCookie("SHUKEILASTLOGDATE");
		}
	}
}
var lastlogdate = getCookie("SHUKEILASTLOGDATE");
if (lastlogdate.match(/^\d{4}\/\d{2}\/\d{2}$/) == null) {
	lastlogdate = "2011/01/01";
}
if (lctschs != null) {
	var i;
	for (i in lctschs) {
		if (lctschs[i].match(/^lastlogdate$/) != null) {
			document.open();
			document.writeln("<p><font color=red>"+lastlogdate+"</font></p>");
			document.close();
		}
	}
}

//ログファイル名の生成
function makeFileName(y, m, d) {
	return "sca" + y + "" + (m<10?"0":"") + m + "" + (d<10?"0":"") + d + ".log";
}

//ログ取得用URLの生成
function makeLogURL(y, m, d) {

	//ログ保存フォルダ
	var logplace = "";

	//キャッシュ対策
	var dt1 = new Date(lastlogdate);
	var dt2 = new Date(y, m - 1, d);
	var tm1 = dt1.getTime();
	var tm2 = dt2.getTime();
	if (tm2 < tm1) {
		dt2 = new Date(y + (m>11?1:0), m % 12, 1);
	} else {
		dt2 = new Date();
		var yy = dt2.getYear();
		if (yy < 1900) {
			yy += 1900;
		}
		var n = dt2.getMinutes();
		n = Math.floor(n / 3) * 3 + 5;
		dt2 = new Date(yy, dt2.getMonth() , dt2.getDate(), dt2.getHours(), n, 0);
	}
	var vr1 = "?time=" + dt2.getTime();

	return logplace + makeFileName(y, m, d) + vr1;
}

//ログ表示時の各ログのタイトルの生成
function makeLogTitle(y, m, d) {
	//例
	//return y + "年" + m + "月" + "日の対戦ログ";

	return makeFileName(y, m, d);
}

//XMLHttpRequestでファイル取得のリクエスト送信
function loadTextFile(fName)
{
	if (httpObj == null) {
		httpObj = createXMLHttpRequest(displayData);
	}
	if (httpObj)
	{
		httpObj.open("GET", fName, true);
		httpObj.send(null);
	}
}


//XMLHttpRequestからの受信（ファイル取得）
function displayData()
{
	var rs=httpObj.readyState;
	var st = 0;
	try {
		st = httpObj.status;
	} catch( e ) {
		st = 0;
	}
	if ((rs == 4) && (st == 200)) { //ダウンロード成功
		var s = httpObj.responseText;
		var lb=getLobbyName(); //ロビー
		var sp = s.split('\n');
		var rf = escape("|").replace(/\%/,"\\%") + "(" + escape(" ").replace(/\%/,"\\%") + ")"
			+ "+(" + escape("四").replace(/\%/,"\\%") + "|" + escape("三").replace(/\%/,"\\%")  + ")"
			+ escape("般").replace(/\%/,"\\%") 
			+ "(" + escape("東").replace(/\%/,"\\%") + "|" + escape("南").replace(/\%/,"\\%")  + ")"
			+ "(" + escape("喰").replace(/\%/,"\\%") + "|" + escape("－").replace(/\%/,"\\%")  + ")"
			+ "(" + escape("赤").replace(/\%/,"\\%") + "|" + escape("－").replace(/\%/,"\\%")  + ")"
			+ "(" + escape("速").replace(/\%/,"\\%") + "|" + escape("－").replace(/\%/,"\\%") + "|)"
			+ "(" + escape(" ").replace(/\%/,"\\%") + ")+" + escape("|").replace(/\%/,"\\%");
		var re = new RegExp(rf);
		var rule_np = escape(getNumberOfPlayers()==4?"四":"三");
		var rule_lng = escape(getPlayTimeLong()==1?"東":"南");
		var arr = new Array("全","喰赤","喰－","－－");
		var rule_rule = escape(arr[getPlayRule()]);
		var fRule = false;
		var es;
		s = ""; 
		var i, r = makeLogTitle(shyear, shmonth, shday) + "\n";
		var r2 = r;
		for(i = 0; i < sp.length; i++){
			if (sp[i].substring(0, 5) == lb) {
				r2 += sp[i] + "\n";
				//r += sp[i] + "\n";
				es = escape(sp[i]);
				if (re.test(es)) {
					fRule = true;
					if (rule_np != RegExp.$2) {
						fRule = false;
					}
					if (fRule && (getPlayTimeLong()>0)) {
						if (rule_lng != RegExp.$3) {
							fRule = false;
						}
					}
					if (fRule && (getPlayRule()>0)) {
						if (rule_rule != (RegExp.$4 + RegExp.$5)) {
							fRule = false;
						}
					}
					if (fRule) {
						r += sp[i] + "\n";
					}
				}
			}
		}
		logdata += r;
		logalldata += r2;

		shday++;
		loadTextFile(makeLogURL(shyear, shmonth, shday)); //次の日のログをリクエスト

	} else if (rs == 4) { //ダウンロード失敗
	
		//キャッシュ対策
		var dt1 = new Date(lastlogdate);
		var dt2 = new Date(shyear, shmonth - 1, shday - 2);
		var tm1 = dt1.getTime();
		var tm2 = dt2.getTime();
		if (tm1 < tm2) {
			var y = dt2.getYear();
			var m = dt2.getMonth() - 0 + 1;
			var d = dt2.getDate();
			if (y < 1900) {
				y += 1900;
			}
			lastlogdate = y + "/" + (m<10?"0":"") + m + "/" + (d<10?"0":"") + d;
			setCookie("SHUKEILASTLOGDATE", lastlogdate);
		}

		//ランキング集計開始
		calc();
		var lg = getLogDisplay(); //ログ表示するかしないか
		if (lg == 1) {
			setLogText(logalldata);
		} else if (lg == 2) {
			setLogText(logdata);
		}
		logdata = "";
		logalldata = "";

	} else { //ダウンロード途中
		var s = "Loading..." + makeFileName(shyear, shmonth, shday) 
				+ " [readyState=" + rs + ", status=" + st + "]<br>";
		setTestMessageText(s);
	}
}

