﻿

//-----------↓ここからフォーム関連↓-----------//

//除外リストの記憶
function saveExclude()
{
	var s = getExcludePlayers();
	setCookie("EXCLUDEMEMBER",s);
}

//設定条件のURLの作成
function makeSpecialURL() {
	var arr = new Array();
	arr['lby'] = "lby=" + getLobbyName();
	arr['y'] = "y=" + getShukeiYear();
	arr['m'] = "m=" + getShukeiMonth();
	if (getLogDisplay() > 0) {
		arr['log'] = "log=" + getLogDisplay();
	}
	if (getNumberOfPlayers() == 3) {
		arr['snm'] = "sanma";
	}
	if (getPlayTimeLong() > 0) {
		arr['lng'] = "lng=" + getPlayTimeLong();
	}
	if (getPlayRule() > 0) {
		arr['rule'] = "rule=" + getPlayRule();
	}
	if (getMinimumPlayCount() > 1) {
		arr['min'] = "min=" + getMinimumPlayCount();
	}
	if (getPlayCountLimit() > 0) {
		if (getCountRule() == 1) {
			arr['last'] = "last";
		}
		arr['cnt'] = "cnt=" + getPlayCountLimit();
	}
	var i, r="?";
	var a = e2a33(getExcludePlayers());
	for (i in a) {
		if (a[i].match(/^NoName$/)) {
			arr['nm'] = "noname";
			break;
		}
	}
	for (i in arr) {
		r += arr[i] + "&";
	}

	r += "calc";
	location.href.match(/^([^\?]+)(\?.*|)$/);
	r = RegExp.$1 + r;

	setSpecialURL("<small><a href='" + r + "'>" + r + "</a></small>");
}

//集計ボタンクリックの処理
function startGetLog(){
	makeSpecialURL();
	setTestMessageText("");
	setResultText("<center>しばらくお待ちください</center>");
	var y, m;
	logdata = "";
	logalldata = "";
	shyear = getShukeiYear();
	shmonth = getShukeiMonth();

	setLogText('');
	shday = 1;
	loadTextFile(makeLogURL(shyear, shmonth, shday));
}

//フォームの初期値設定
(function () {
	var d, y=-1 ,m=-1;

	/* */
	var ee = getCookie("EXCLUDEMEMBER");
	if (ee.length>0) {
		setExcludePlayers(ee);
	}
	/* */
	d = new Date();
	y = d.getYear();
	if (y < 1900) {
		y += 1900;
	}
	m = d.getMonth() - 0 + 1;


	var fCalc = false;
	var fSengetsu = false;
	var nSanma = 4;

	var p = location.search;
	var sp = null, sp2 = null;
	if (p.length > 0) {
		sp = p.substring(1).split("&");
		var i;
		for (i in sp) {
			sp2 = sp[i].split("=");
			if ((sp2[0].match(/^y$/i) != null) && (sp2.length>1))  { //年指定
				if (!isNaN(sp2[1])) {
					var yy = parseInt(sp2[1]);
					if ((yy>=2007) && (yy<y)) {
						y = yy;
					}
				}
			}
			if ((sp2[0].match(/^m$/i) != null) && (sp2.length>1)) { //月指定
				if (!isNaN(sp2[1])) {
					var mm = parseInt(sp2[1]);
					if ((mm>=1) && (mm<=12)) {
						m = mm;
					}
				}
			}
			if (sp2[0].match(/^sengetsu$/i)) {
				fSengetsu = true;
			}
			if (sp2[0].match(/^sanma$/i)) {
				nSanma = 3;
			}
			if (sp2[0].match(/^calc$/i)) {
				fCalc = true;
			}
			if (sp2[0].match(/^last$/i)) { //最後の
				setCountRule(1);
			}
			if ((sp2[0].match(/^lby$/i) != null) && (sp2.length>1)) { //ロビー指定
				if (sp2[1].match(/([lLcC]\d{4})/)) {
					setLobbyName(RegExp.$1.toUpperCase());
				}
			}
			if ((sp2[0].match(/^lng$/i) != null) && (sp2.length>1)) { //長さ指定
				if (!isNaN(sp2[1])) {
					var g = parseInt(sp2[1]);
					if ((g>=0) && (g<=2)) {
						setPlayTimeLong(g);
					}
				}
			}
			if ((sp2[0].match(/^rule$/i) != null) && (sp2.length>1)) { //長さ指定
				if (!isNaN(sp2[1])) {
					var g = parseInt(sp2[1]);
					if ((g>=0) && (g<=3)) {
						setPlayRule(g);
					}
				}
			}
			if ((sp2[0].match(/^min$/i) != null) && (sp2.length>1)) { //最小対戦数指定
				if (!isNaN(sp2[1])) {
					var g = parseInt(sp2[1]);
					if (g>1) {
						setMinimumPlayCount(g);
					}
				}
			}
			if ((sp2[0].match(/^cnt$/i) != null) && (sp2.length>1)) { //対戦数指定
				if (!isNaN(sp2[1])) {
					var g = parseInt(sp2[1]);
					if (g>0) {
						setPlayCountLimit(g);
					}
				}
			}
			if ((sp2[0].match(/^log$/i) != null) && (sp2.length>1)) { //ログ表示指定
				if (!isNaN(sp2[1])) {
					var g = parseInt(sp2[1]);
					if ((g>=0) && (g<=2))  {
						setLogDisplay(g);
					}
				}
			}
			if (sp2[0].match(/^noname$/i)) {
				var v = getExcludePlayers();
				var a = e2a33(v);
				var fn = true, j;
				for (j in a) {
					if (a[j].match(/^NoName$/)) {
						fn = false;
						break;
					}
				}
				if (fn) {
					setExcludePlayers(v+ "\nNoName");
				}
			}
		}
	}
	
	if (fSengetsu) {
		var d2 = new Date(y, m-2,1);
		var yy = d2.getYear();
		if (yy<1900) {
			yy+=1900;
		}
		if (yy>=2007) {
			y = yy;
			m = d2.getMonth() - 0 + 1;
		}
	}

	setNumberOfPlayers(nSanma);

	setShukeiYear(y);
	setShukeiMonth(m);

	if (fCalc) {
		startGetLog();
	}
})();

//-----------↑ここまでフォーム関連↑-----------//
